/**************************************************************************************************
 * MAT 259 - Winter 2020                                                                          *
 * Data Visualization - Project 3                                                                 *     
 *                                                                                                *
 * Author: Evgeny Noi                                                                             * 
 * Supervisor: George Legrady                                                                     *
 * TA: Weidi Zhang                                                                                *
 * Data Source: Memorial Foundation                                                               *
 * Coding Examples: Guanyu Chen                                                                   *
 *                                                                                                *
 * Purpose: Explore the patterns for places of birth, residence                                   *
 *          and relocation of deported Volga Germans                                              *
 *                                                                                                *
 *                                                                                                *
 * Usage: 1. Click the checkboxes on the left to explore location of deportation                  * 
 *                                                                                                *
 *        2. Press 1 to show/hide the longitude axis                                              *
 *                                                                                                *
 *        3. Press 2 to show/hide the latitude axis                                               *
 *                                                                                                *
 *        4. Press S to show/hide the mapping of personal identification number to place of birth *
 *                                                                                                *
 *        5. Press D to show/hide the mapping of personal identification number to age at trial   *
 *                                                                                                *
 *        6. Press Space to remove all graphs                                                     *
 *                                                                                                *
 *                                                                                                *
 *************************************************************************************************/

//import libraries 
import peasy.*;
import controlP5.*;
PeasyCam cam;
ControlP5 cp5;
import java.util.Map;

// vars 
CheckBox checkbox0, checkbox1, checkbox2, checkbox3, checkbox4, checkbox5, checkbox6, checkbox7, checkbox8, checkbox9, checkbox10, checkbox11, checkbox12, checkbox13, checkbox14;

// declare the arraylist to fill the arraylist with video objects
ArrayList<Liner>liners = new ArrayList<Liner>();

// font 
PFont f;

// initial color hashmap
HashMap<String, Integer> clr_map = new HashMap<String, Integer>();

Table table;
//float min_width, max_width;
//int[] fontSize = {280, 14, 12};
//int[] fontColor = {240, 180};

void setup() {
  fullScreen(P3D); 
  f = createFont("Arial", 100, true);
  //size(1600, 1200, P3D);
  //cam = new PeasyCam(this, 250);
  //cam.setMinimumDistance(20);
  //cam.setMaximumDistance(1000);
  
  cam = new PeasyCam(this, 150);

  cam.setMinimumDistance(1);
  cam.setMaximumDistance(800);
  
  // Set the angle of view - like changing the lens on a camera PI/2 (wide angle); PI/6 normal lens; PI/12 (telephoto)
  float fov = PI/6; // field of view try between PI/2 to PI/10
  float cameraZ = (height/2.0) / tan(PI/6);
  perspective(fov, float(width)/float(height), cameraZ/10.0, cameraZ*10.0);

  loadData(); 
  gui();
}

void draw() {
  
  // rotate for view
  rotateX(-PI/20);
  rotateY(-PI/5);
  //rotateZ(-PI/5);
  
  
  create_clr_map();  
  background(0); 
  if (draw_pt && show_long) {
    drawLongitude();
    longLable();
    zLable();}
  if (draw_pt && show_lat) {
    drawLatitude();
    latLable();
    zLable2();
  }
    
  if (draw_s && show_long) {
    drawLongitude();
    longLable();
    zLable();  
}
  if (draw_s && show_lat2) {
    drawLatitude2();
    latLable2(); 
    zLable2();  
}
  //drawCircle();
  //checker();

  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  if (havetext) drawInfo();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);

  pushMatrix();
  smooth();
  // draw ordinates
  //if (Ord) drawWeek();
  drawData();
  popMatrix();

  if (cp5.getWindow().isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }

}

void drawData() {

  for (int i = 0; i < 15; i++) {
    if (class_ctrl[i]) {
      draw_fn(i);
    }
  }
}
