//all vars in file
//,PersonID,gender,trial_age,term,destination,new_birth,new_live,outcome,Death,n_birth,n_live,n_dest

int numRows;

void loadData() {
  // Load CSV file into a Table object
  // "header" option indicates the file has a header row
  table = loadTable("wolga22.csv", "header");
  
  numRows = table.getRowCount();

  // The size of the array is determined by the total number of rows in the CSV
  //liners = new Liner[table.getRowCount()]; 

  //iterate over all the rows in a table
  for (int i = 0; i < table.getRowCount(); i++) {
    TableRow row = table.getRow(i);
    // You can access the fields via their column name (or index)
    int person_id = row.getInt("PersonID");
    int gen = row.getInt("gender");
    int trial_age = row.getInt("trial_age");
    int term = row.getInt("term");
    
    String destin = row.getString("destination");
    String new_birth = row.getString("new_birth"); 
    String new_live = row.getString("new_live"); 
    
    String outcome = row.getString("outcome");
    
    int death = row.getInt("Death"); 
    
    // this will be used as actual coordinates
    int n_birth = row.getInt("n_birth");
    int n_live = row.getInt("n_live");
    int n_dest = row.getInt("n_dest");
    
    // set radius to be age variable 
    float r = map(trial_age, 1, 84, 1, 100);
    float ra = map(trial_age, 1, 84, -180, 180);
    //float r = 100; 
    
    // map theta to the person_id
    float mapped_theta = map(person_id, 0, 20629, -180, 180);
    
    // first draft mapping 
    // map values ^|^ to    
    //float map_nb = map(n_birth, 0, 48, -180, 180);
    float map_nb = map(n_birth, 0, 913, -180, 180);
    //float map_nl = map(n_live, 0, 48, -180, 180);
    float map_nl = map(n_live, 0, 913, -180, 180);
    float map_de = map(n_dest, 0, 14, -180, 180);
    //float map_de = map(n_dest, 1, 7760, -PI, PI);
    
    // unique id vs place of birth
    float x1 = r * sin(radians(mapped_theta)) * cos(radians(map_nb));
    float y1 = r * sin(radians(mapped_theta)) * sin(radians(map_nb));
    float z1 = r * cos(radians(mapped_theta));
    
    // unique id vs age 
    float x2 = r * sin(radians(mapped_theta)) * cos(radians(ra));
    float y2 = r * sin(radians(mapped_theta)) * sin(radians(ra));
    float z2 = r * cos(radians(mapped_theta));
    
    // place of birth vs place of origin 
    float x3 = r * sin(radians(map_nb)) * cos(radians(map_nl));
    float y3 = r * sin(radians(map_nb)) * sin(radians(map_nl));
    float z3 = r * cos(radians(map_nb));

    
    // Make a Liner object out of the data read
    //liners[i] = new Liner(person_id, gen, r, term, destin, n_dest, new_birth, new_live, outcome, death, x1, y1, z1, x2, y2, z2, x3, y3, z3);
    liners.add(new Liner(person_id, gen, r, term, destin, n_dest, new_birth, new_live, outcome, death, x1, y1, z1, x2, y2, z2, x3, y3, z3));
  }
}
